﻿@page "/program-list"
@page "/program-list/{SearchString}"
@inject HttpClient HttpClient

<PageTitle Title="プログラム一覧" />

<MudTable Items="_programs" Loading="_isLoading" Hover="true" Striped="true" Dense="true" FixedHeader="true" Height="550px"
          Filter="new Func<ProgramEntity,bool>(FilterFunc1)" Class="mt-2">
    <ToolBarContent>
        <MudTextField @bind-Value="SearchString" Placeholder="タグ検索" Adornment="Adornment.Start" AdornmentIcon="@Icons.Material.Filled.Search" IconSize="Size.Medium" Class="mt-0"></MudTextField>
        <MudSpacer />
        <MudTooltip Text="新規追加">
            <MudFab Color="Color.Primary" Icon="@Icons.Material.Filled.Add" Size="Size.Small" Link="@($"/program-detail/{nameof(PageMode.Create)}")" />
        </MudTooltip>
    </ToolBarContent>
    <HeaderContent>
        <MudTh>
            <MudTableSortLabel SortBy="new Func<ProgramEntity, object>(x =>x.ProgramId)">
                @programForLabel.GetDisplayName(p => p.ProgramId)
            </MudTableSortLabel>
        </MudTh>
        <MudTh>
            <MudTableSortLabel SortBy="new Func<ProgramEntity, object>(x =>x.ProgramName)">
                @programForLabel.GetDisplayName(p => p.ProgramName)
            </MudTableSortLabel>
        </MudTh>
        <MudTh>@programForLabel.GetDisplayName(p => p.Purpose)</MudTh>
        <MudTh>@programForLabel.GetDisplayName(p => p.FunctionalOverview)</MudTh>
        <MudTh>@programForLabel.GetDisplayName(p => p.Tags)</MudTh>
        <MudTh>操作</MudTh>
    </HeaderContent>
    <RowTemplate>
        <MudTd>@context.ProgramId</MudTd>
        <MudTd>@context.ProgramName</MudTd>
        <MudTd>@context.Purpose</MudTd>
        <MudTd>@context.FunctionalOverview</MudTd>
        <MudTh>
            <MudChipSet>
                @foreach (var tag in context.Tags)
                {
                    <MudChip Text="@tag.TagName" Link="@($"/program-list/{tag.TagName}")"></MudChip>
                }
            </MudChipSet>
        </MudTh>
        <MudTd>
            <MudTooltip Text="照会">
                <MudFab Icon="@Icons.Material.Filled.ListAlt" Size="Size.Small" Link="@($"/program-detail/{nameof(PageMode.Show)}/{context.Id}")"></MudFab>
            </MudTooltip>
            <MudTooltip Text="編集">
                <MudFab Icon="@Icons.Material.Filled.Edit" Size="Size.Small" Link="@($"/program-detail/{nameof(PageMode.Edit)}/{context.Id}")"></MudFab>
            </MudTooltip>
            <MudTooltip Text="削除">
                <MudFab Icon="@Icons.Material.Filled.Delete" Size="Size.Small" Link="@($"/program-detail/{nameof(PageMode.Delete)}/{context.Id}")"></MudFab>
            </MudTooltip>
        </MudTd>
    </RowTemplate>
</MudTable>

@code {
    [Parameter]
    public string SearchString { get; set; } = "";

    private bool _isLoading = false;
    private IEnumerable<ProgramEntity> _programs = new List<ProgramEntity>();
    private ProgramEntity programForLabel = new();

    protected async override Task OnInitializedAsync()
    {
        _isLoading = true;
        try
        {
            _programs = await HttpClient.GetFromJsonAsync<List<ProgramEntity>>("api/Programs");
        }
        catch (Exception ex)
        {
            Snackbar.Add(ex.Message, Severity.Error);
        }
        _isLoading = false;
    }

    private bool FilterFunc1(ProgramEntity program) => FilterFunc(program, SearchString);

    private bool FilterFunc(ProgramEntity program, string searchString)
    {
        if (string.IsNullOrWhiteSpace(searchString))
            return true;
        //if (program.ProgramId.Contains(searchString, StringComparison.OrdinalIgnoreCase))
        //    return true;
        //if (program.ProgramName.Contains(searchString, StringComparison.OrdinalIgnoreCase))
        //    return true;
        //if (program.Purpose != null && program.Purpose.Contains(searchString, StringComparison.OrdinalIgnoreCase))
        //    return true;
        foreach (var tag in program.Tags)
        {
            if (tag.TagName.Equals(searchString))
            {
                return true;
            }
        }
        return false;
    }

    private void ClickTag(string tag)
    {
        SearchString = tag;
    }
}